package com.aibonware.inaver.task;

import EDU.oswego.cs.dl.util.concurrent.*;

/**
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
public class TaskList extends BoundedLinkedQueue {
	public TaskList() {}

	public void putFirst(Task x[]) throws InterruptedException {
		LinkedNode p = null;

		if (x == null) throw new IllegalArgumentException();
		if (Thread.interrupted()) throw new InterruptedException();

		synchronized(putGuard_) {

		  if (putSidePutPermits_ <= 0) { // wait for permit. 
			synchronized(this) {
			  if (reconcilePutPermits() <= 0) {
				try {
				  for(;;) {
					wait();
					if (reconcilePutPermits() > 0) {
					  break;
					}
				  }
				}
				catch (InterruptedException ex) { 
				  notify(); 
				  throw ex; 
				}
			  }
			}
		  }

		  --putSidePutPermits_;
		
		  if(isEmpty()) {
		  	for(int i=x.length-1; i>=0; i--) {
				  insert(x[i]);
		  	}
		  } else {
			  synchronized(head_) {
				LinkedNode prev = head_;

				for(int i=0; i<x.length; i++) {
					p = new LinkedNode(x[i]);

					LinkedNode next = prev.next;
					prev.next = p;
					p.next = next;
					
					prev = p;
				}
			  }
		  }
		}
		// call outside of lock to loosen put/take coupling
		allowTake();
	}

	public void putFirst(Task x) throws InterruptedException {
		putFirst(new Task[] {x});
	}
}
